---
title: "Building a case for my CRXN router (Raspberry Pi case)"
author: Tristan B. Kildaire
date: 2020-12-02
---

# Reason for a case

DSo I could have easily bought a case for the router of mine that I
put together for the CRXN network node `deavmi.crxn.banghoe`
but we (Gustav and I) decided we could re-purpose the existing
power supply I had laying around.

{{<bruh>}}
<center>
    <img src="/img/gustav_case_for_rpi/power_supply_intro.jpg" alt="" width="626" height="352">
    <p>>The power supply we decided to use (the insides)</p>
</center>
{{</bruh>}}

The nice thing about this power supply is that it was able to fit
a black anti-conductive sheath from another power supply that was
previously containing my Pi. Now we didn't actually end up using
it as you will see with the mounting we did but if it were to fall
onto the bottom of the casing then it would be safe.

{{<bruh>}}
<center>
    <img src="/img/gustav_case_for_rpi/power_supply_intro_outer.jpg" alt="" width="612" height="458">
    <p>The outside of the power supply</p>
</center>
{{</bruh>}}

As you can see it's a normal ATX power supply (not an SFF one
like that of the one previously housing my CRXN router).

For mounting we decided we wouldn't let the Pi simply sit on
the bottom of the power supply on the sheath but rather would
mount the Pi on one of the internal mounting points of the
power supply.

{{<bruh>}}
<center>
    <img src="/img/gustav_case_for_rpi/mounting.jpg" alt="" width="625" height="350">
    <p>PSU's internal mounting</p>
</center>
{{</bruh>}}

{{<bruh>}}
<center>
    <img src="/img/gustav_case_for_rpi/pi_mount_hole.jpg" alt="" width="623" height="348">
    <p>Pi mounting hole</p>
</center>
{{</bruh>}}

So what we did was then use the above Pi
mounting hole and screwed a screw through it into the
internal mounting point inside the power supply and ended
up with something as below (levitated by one screw).

{{<bruh>}}
<center>
    <img src="/img/gustav_case_for_rpi/mounted.jpg" alt="" width="620" height="348">
    <p>Pi mounted internally</p>
</center>
{{</bruh>}}

We then made use of things other than the
power supply's internal mounting points by using the fan
too! We attached the fan's connection header to the
Raspberry Pi's GPIO pins and it worked (albeit slower than
normally).

The cable management situation is as follows. The USB
cable you see in front (in the image below) is for the USB
Ethernet adapter:

{{<bruh>}}
<center>
    <img src="/img/gustav_case_for_rpi/powered_on.jpg" alt="" width="616" height="346">
    <p>The front of the power supply with the USB Ethernet
adapter hanging out</p>
</center>
{{</bruh>}}

As for the power supply for the Pi, that USB cable
comes in the back via the elliptical cut at the top of
the backside of the power supply:

{{<bruh>}}
<center>
    <img src="/img/gustav_case_for_rpi/top_view.jpg" alt="" width="635" height="476">
    <p>Top view of the Pi</p>
</center>
{{</bruh>}}

And now the case looks like finally:

{{<bruh>}}
<center>
    <img src="/img/gustav_case_for_rpi/case%20front.jpg" alt="" width="623" height="467">
    <p>Case when opened</p>
</center>
{{</bruh>}}

{{<bruh>}}
<center>
    <img src="/img/gustav_case_for_rpi/case_closed.jpg" alt="" width="614" height="460">
    <p>Case when closed</p>
</center>
{{</bruh>}}

---

# And that's a wrap

{{<bruh>}}
<center>
    <img src="/img/gustav_case_for_rpi/bruh.jpg" alt="" width="614" height="460">
    <p>Gustav inspecting the case ;) (Also what we <a
href="/img/gustav_case_for_rpi/inspection.mp4">named</a> it)</p>
</center>
{{</bruh>}}

{{<bruh>}}
See a full tour video <a href="/img/gustav_case_for_rpi/final.mp4">here</a>
{{</bruh>}}